aubio 0.4.2~alpha

- Main Page
- Data Structures
- Files
- Examples

- File List
- Globals

Typedefs | Functions
tempo.h File Reference

Tempo detection object. More...

Go to the source code of this file.

## Typedefs
typedef struct _aubio_tempo_t | aubio_tempo_t
| tempo detection structure

## Functions
aubio_tempo_t * | new_aubio_tempo (char_t *method, uint_t buf_size, uint_t hop_size, uint_t samplerate)
| create tempo detection object More...
void | aubio_tempo_do (aubio_tempo_t *o, fvec_t *input, fvec_t *tempo)
| execute tempo detection More...
uint_t | aubio_tempo_get_last (aubio_tempo_t *o)
| get the time of the latest beat detected, in samples More...
smpl_t | aubio_tempo_get_last_s (aubio_tempo_t *o)
| get the time of the latest beat detected, in seconds More...
smpl_t | aubio_tempo_get_last_ms (aubio_tempo_t *o)
| get the time of the latest beat detected, in milliseconds More...
uint_t | aubio_tempo_set_silence (aubio_tempo_t *o, smpl_t silence)
| set tempo detection silence threshold More...
smpl_t | aubio_tempo_get_silence (aubio_tempo_t *o)
| get tempo detection silence threshold More...
uint_t | aubio_tempo_set_threshold (aubio_tempo_t *o, smpl_t threshold)
| set tempo detection peak picking threshold More...
smpl_t | aubio_tempo_get_threshold (aubio_tempo_t *o)
| get tempo peak picking threshold More...
smpl_t | aubio_tempo_get_bpm (aubio_tempo_t *o)
| get current tempo More...
smpl_t | aubio_tempo_get_confidence (aubio_tempo_t *o)
| get current tempo confidence More...
void | del_aubio_tempo (aubio_tempo_t *o)
| delete tempo detection object More...

## Detailed Description

Tempo detection object.

This object stores all the memory required for tempo detection algorithm and returns the estimated beat locations.

Definition in file tempo.h.

## Function Documentation

void aubio_tempo_do | ( | aubio_tempo_t * | o,
|  | fvec_t * | input,
|  | fvec_t * | tempo
| ) |  |

execute tempo detection

Parameters

  o | beat tracking object
  input | new samples
  tempo | output beats

Examples:
  examples/aubiotrack.c, and tempo/test-tempo.c.

smpl_t aubio_tempo_get_bpm | ( | aubio_tempo_t * | o | ) |

get current tempo

Parameters

  o | beat tracking object

Returns
  the currently observed tempo, or `0` if no consistent value is found

Examples:
  tempo/test-tempo.c.

smpl_t aubio_tempo_get_confidence | ( | aubio_tempo_t * | o | ) |

get current tempo confidence

Parameters

  o | beat tracking object

Returns
  confidence with which the tempo has been observed, `0` if no consistent value is found.

Examples:
  tempo/test-tempo.c.

uint_t aubio_tempo_get_last | ( | aubio_tempo_t * | o | ) |

get the time of the latest beat detected, in samples

Parameters

  o | tempo detection object as returned by new_aubio_tempo

Examples:
  tempo/test-tempo.c.

smpl_t aubio_tempo_get_last_ms | ( | aubio_tempo_t * | o | ) |

get the time of the latest beat detected, in milliseconds

Parameters

  o | tempo detection object as returned by new_aubio_tempo

Examples:
  tempo/test-tempo.c.

smpl_t aubio_tempo_get_last_s | ( | aubio_tempo_t * | o | ) |

get the time of the latest beat detected, in seconds

Parameters

  o | tempo detection object as returned by new_aubio_tempo

Examples:
  examples/aubiotrack.c, and tempo/test-tempo.c.

smpl_t aubio_tempo_get_silence | ( | aubio_tempo_t * | o | ) |

get tempo detection silence threshold

Parameters

  o | tempo detection object as returned by new_aubio_tempo()

Returns
  current silence threshold

smpl_t aubio_tempo_get_threshold | ( | aubio_tempo_t * | o | ) |

get tempo peak picking threshold

Parameters

  o | tempo detection object as returned by new_aubio_tempo()

Returns
  current tempo detection threshold

uint_t aubio_tempo_set_silence | ( | aubio_tempo_t * | o,
|  | smpl_t | silence
| ) |  |

set tempo detection silence threshold

Parameters

  o | beat tracking object
  silence | new silence threshold, in dB

Returns
  `0` if successful, non-zero otherwise

uint_t aubio_tempo_set_threshold | ( | aubio_tempo_t * | o,
|  | smpl_t | threshold
| ) |  |

set tempo detection peak picking threshold

Parameters

  o | beat tracking object
  threshold | new threshold

Returns
  `0` if successful, non-zero otherwise

Examples:
  examples/aubiotrack.c.

void del_aubio_tempo | ( | aubio_tempo_t * | o | ) |

delete tempo detection object

Parameters

  o | beat tracking object

Examples:
  examples/aubiotrack.c, and tempo/test-tempo.c.

aubio_tempo_t* new_aubio_tempo | ( | char_t * | method,
|  | uint_t | buf_size,
|  | uint_t | hop_size,
|  | uint_t | samplerate
| ) |  |

create tempo detection object

Parameters

  method | beat tracking method, unused for now (use "default")
  buf_size | length of FFT
  hop_size | number of frames between two consecutive runs
  samplerate | sampling rate of the signal to analyze

Returns
  newly created aubio_tempo_t if successful, `NULL` otherwise

Examples:
  examples/aubiotrack.c, and tempo/test-tempo.c.